// CodeGear C++Builder
// Copyright (c) 1995, 2010 by Embarcadero Technologies, Inc.
// All rights reserved

// (DO NOT EDIT: machine generated header) 'dx_textbox.pas' rev: 22.00

#ifndef Dx_textboxHPP
#define Dx_textboxHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Menus.hpp>	// Pascal unit
#include <dx_utils.hpp>	// Pascal unit
#include <dx_scene.hpp>	// Pascal unit
#include <dx_objects.hpp>	// Pascal unit
#include <dx_vgcore.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Dx_textbox
{
//-- type declarations -------------------------------------------------------
class DELPHICLASS TdxTextBox3D;
class PASCALIMPLEMENTATION TdxTextBox3D : public Dx_objects::TdxShape3D
{
	typedef Dx_objects::TdxShape3D inherited;
	
private:
	Classes::TNotifyEvent FOnChange;
	bool FReadOnly;
	int FSelStart;
	int FSelLength;
	int FCaretPosition;
	int FMaxLength;
	int FFirstVisibleChar;
	bool FLMouseSelecting;
	bool FNeedChange;
	bool FDisableCaret;
	bool FPassword;
	Menus::TPopupMenu* FPopupMenu;
	Classes::TNotifyEvent FOnTyping;
	System::WideString FText;
	Dx_scene::TdxFont* FFont;
	System::UnicodeString FBackground;
	System::UnicodeString FSelection;
	bool FShowBackground;
	void __fastcall InsertText(const System::WideString AText);
	int __fastcall GetSelLength(void);
	int __fastcall GetSelStart(void);
	System::WideString __fastcall GetSelText(void);
	void __fastcall SetSelLength(const int Value);
	void __fastcall SetSelStart(const int Value);
	Dx_vgcore::TvxRect __fastcall GetSelRect(void);
	void __fastcall SetCaretPosition(const int Value);
	int __fastcall GetCoordinatePosition(float x);
	void __fastcall SetMaxLength(const int Value);
	int __fastcall GetNextWordBeging(int StartPosition);
	int __fastcall GetPrivWordBeging(int StartPosition);
	void __fastcall UpdateFirstVisibleChar(void);
	void __fastcall UpdateCaretePosition(void);
	void __fastcall SetPassword(const bool Value);
	void __fastcall CreatePopupMenu(void);
	void __fastcall DoCopy(System::TObject* Sender);
	void __fastcall DoCut(System::TObject* Sender);
	void __fastcall DoDelete(System::TObject* Sender);
	void __fastcall DoPaste(System::TObject* Sender);
	void __fastcall UpdatePopupMenuItems(void);
	void __fastcall DoSelectAll(System::TObject* Sender);
	void __fastcall SetFont(const Dx_scene::TdxFont* Value);
	void __fastcall SetBackground(const System::UnicodeString Value);
	void __fastcall SetSelection(const System::UnicodeString Value);
	void __fastcall SetShowBackground(const bool Value);
	
protected:
	virtual void __fastcall Change(void);
	float __fastcall GetPasswordCharWidth(void);
	float __fastcall TextWidth(const System::WideString Str);
	virtual void __fastcall SetText(const System::WideString Value);
	virtual void __fastcall KeyDown(System::Word &Key, System::WideChar &KeyChar, Classes::TShiftState Shift);
	virtual void __fastcall KeyUp(System::Word &Key, System::WideChar &KeyChar, Classes::TShiftState Shift);
	virtual void __fastcall ShapeMouseDown(Controls::TMouseButton Button, Classes::TShiftState Shift, float X, float Y);
	virtual void __fastcall ShapeMouseMove(Classes::TShiftState Shift, float X, float Y);
	virtual void __fastcall ShapeMouseUp(Controls::TMouseButton Button, Classes::TShiftState Shift, float X, float Y);
	void __fastcall FontChanged(System::TObject* Sender);
	virtual void __fastcall EnterFocus(void);
	virtual void __fastcall KillFocus(void);
	virtual void __fastcall ContextMenu(const Dx_vgcore::TvxPoint &ScreenPosition);
	
public:
	__fastcall virtual TdxTextBox3D(Classes::TComponent* AOwner);
	__fastcall virtual ~TdxTextBox3D(void);
	virtual bool __fastcall RayCastIntersect(const Dx_scene::TdxVector &RayPos, const Dx_scene::TdxVector &RayDir, Dx_scene::TdxVector &Intersection);
	virtual void __fastcall Paint(void);
	void __fastcall ClearSelection(void);
	void __fastcall CopyToClipboard(void);
	void __fastcall CutToClipboard(void);
	void __fastcall PasteFromClipboard(void);
	void __fastcall SelectAll(void);
	float __fastcall GetCharX(int a);
	__property int CaretPosition = {read=FCaretPosition, write=SetCaretPosition, nodefault};
	__property int SelStart = {read=GetSelStart, write=SetSelStart, nodefault};
	__property int SelLength = {read=GetSelLength, write=SetSelLength, nodefault};
	__property System::WideString SelText = {read=GetSelText};
	__property int MaxLength = {read=FMaxLength, write=SetMaxLength, default=0};
	
__published:
	__property CanFocused = {default=1};
	__property System::UnicodeString Background = {read=FBackground, write=SetBackground};
	__property System::UnicodeString Selection = {read=FSelection, write=SetSelection};
	__property Cursor = {default=-4};
	__property Dx_scene::TdxFont* Font = {read=FFont, write=SetFont};
	__property bool Password = {read=FPassword, write=SetPassword, nodefault};
	__property bool ShowBackground = {read=FShowBackground, write=SetShowBackground, default=1};
	__property System::WideString Text = {read=FText, write=SetText};
	__property bool ReadOnly = {read=FReadOnly, write=FReadOnly, nodefault};
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
	__property Classes::TNotifyEvent OnTyping = {read=FOnTyping, write=FOnTyping};
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Dx_textbox */
#if !defined(DELPHIHEADER_NO_IMPLICIT_NAMESPACE_USE)
using namespace Dx_textbox;
#endif
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// Dx_textboxHPP
